from random import *
from cards import Cards

cards = Cards()


class Dealer:
    def init(self, deck1, deck2, deck3, deck4):
        self.deck1 = deck1
        self.deck2 = deck2
        self.deck3 = deck3
        self.deck4 = deck4
        self.hand = []
        self.score = 0
        self.one_card_score = 0   # the card display to the player

    
    def shuffle_deck(self):
        shuffle(self.deck1)
        shuffle(self.deck2)
        shuffle(self.deck3)
        shuffle(self.deck4)

    
    def deal_card(self):
        decknum = randint(1, 4)
        if decknum == 1:
            return self.deck1.pop()
        elif decknum == 2:
            return self.deck2.pop()
        elif decknum == 3:
            return self.deck3.pop()
        elif decknum == 4:
            return self.deck4.pop()
    
    
    def take_card(self, card):
        self.hand.append(card)
        self.update_score()

        
    def hit(self):
        card = self.deal_card()
        self.take_card(card)
        #print('dealer hit one card')

    
    def update_score(self):
        score = 0
        aces = 0
        for card in self.hand:
            number, c_type = card.split('_')
            score += cards.scores[number]
            if number == 'A':
                aces += 1
        if score > 17 and aces > 0:
            while aces > 0 and score > 21:
                score -= 10
                aces -= 1
        self.score = score
        number, c_type = self.hand[0].split('_')
        self.one_card_score = cards.scores[number]


    def get_one_card_score(self):
        return self.one_card_score


    def get_score(self):
        return self.score
