from cards import Cards
from dealer import Dealer
from player import Player
from rules import Rules
from random import *


rules = Rules()
dealer = Dealer()
player = Player()


deck = Cards.deck
dealer.init(deck[:], deck[:], deck[:], deck[:])
player.init()

dealer.shuffle_deck()
robot = 1
end = 0


# Training Loop
for x in range(0, 1000000):
    rules.deal_hand_cards(player, dealer)
    #print(x)
    new = 1
    while new == 1:
        #print(f'Player\'s Hand: {" - ".join(player.hand)}')
        #print(f'Dealer\'s Hand: {dealer.hand[0]}')

        #if dealer blackjack
        if dealer.get_score() == 21:
            #print(f'Dealer blackjack!. Dealer\'s Hand: {" - ".join(dealer.hand)}')
            break

        # Check players score
        if player.get_score() > 21:
            winner = rules.winner(player, dealer)
            player.updateQStrategy(dealer, winner)
            break
        elif player.get_score() == 21:
            winner = rules.winner(player, dealer)
            player.updateQStrategy(dealer, winner)
            break

        #print(f'Player\'s Current Score: {player.get_score()}')
        #print(f'Dealer\'s One Card Score: {dealer.get_one_card_score()}')

        if robot == 0:
            decision = input("Hit (H) or Stand (S)? ")
        elif robot == 1:
            decision = player.QLearning_strategy(dealer)

        if decision is 'H' or decision is 'h':
            player.hit(dealer)
        elif decision is 'S' or decision is 's':
            # deealer turn
            #print(f'Player Stands, and final Score: {player.get_score()}')
            #print(f'Dealer turn! Dealer\'s Current Hand: {" - ".join(dealer.hand)}, and Dealer\'s Current Score: {dealer.get_score()}')
            while dealer.get_score() < 17:
                dealer.hit()

            # game finished
            winner = rules.winner(player, dealer)
            player.updateQStrategy(dealer, winner)
            break
        else:
            end = 0

    rules.clearHand(player, dealer)

print(f' {player.QSoftStrategy}')
print(f' {player.QStrategy}')
print(f'============================================')
print(f'============================================')


player.basiclosses = 0
player.basicwins = 0
player.basicties = 0
# testing Loop
for x in range(0, 200000):
    rules.deal_hand_cards(player, dealer)

    new = 1
    while new == 1:
        #print(f'Player\'s Hand: {" - ".join(player.hand)}')
        #print(f'Dealer\'s Hand: {dealer.hand[0]}')

        # if dealer blackjack
        if dealer.get_score() == 21:
            #print(f'Dealer blackjack!. Dealer\'s Hand: {" - ".join(dealer.hand)}')
            break

        # Check players score
        if player.get_score() > 21:
            winner = rules.winner(player, dealer)
            player.updateQStrategy(dealer, winner)
            break
        elif player.get_score() == 21:
            winner = rules.winner(player, dealer)
            player.updateQStrategy(dealer, winner)
            break

        #print(f'Player\'s Current Score: {player.get_score()}')
        #print(f'Dealer\'s One Card Score: {dealer.get_one_card_score()}')

        if robot == 0:
            decision = input("Hit (H) or Stand (S)? ")
        elif robot == 1:
            decision = player.QLearning_strategy(dealer)

        if decision is 'H' or decision is 'h':
            player.hit(dealer)
        elif decision is 'S' or decision is 's':
            #print(f'Player Stands, and final Score: {player.get_score()}')
            #print(f'Dealer turn! Dealer\'s Current Hand: {" - ".join(dealer.hand)}, and Dealer\'s Current Score: {dealer.get_score()}')
            while dealer.get_score() < 17:
                dealer.hit()

            # game finished
            winner = rules.winner(player, dealer)

            '''
            if winner == 0:
                print(f'dealer win!')
            elif winner == 1:
                print(f'player win!')
            elif winner == 2:
                print(f'it\'s tie!')
            '''
            
            player.updateQStrategy(dealer, winner)
            break
        else:
            end = 0

    rules.clearHand(player, dealer)

print(f'Record: {player.basicwins}-{player.basiclosses}-{player.basicties}')
print(f'Winning Percent: {round((player.basicwins/(player.basicwins + player.basiclosses))*100, 2)}%')
print(f'Player Units: {player.units}')
print(f'Player Blackjacks: {player.blackjacks}')

