from cards import Cards
from random import *

cards = Cards()


class Player:

    def init(self):
        self.hand = []
        self.score = 0
        self.aces = 0
        self.basicwins = 0
        self.basiclosses = 0
        self.basicties = 0
        self.units = 100
        self.blackjacks = 0

        # with no Ace
        self.QStrategy= {}
        # with Ace
        self.QSoftStrategy = {}


    def take_card(self, card):
        self.hand.append(card)
        self.update_score()


    def update_score(self):
        score = 0
        for card in self.hand:
            number, suit = card.split('_')
            score += cards.scores[number]
            if number == 'A':
                self.aces += 1
        if score > 21 and self.aces > 0:
            while self.aces > 0 and score > 21:
                score -= 10
                self.aces -= 1
        self.score = score

    def get_score(self):
        return self.score

    def hit(self, dealer):
        #print(f'Player Hits.')
        card = dealer.deal_card()
        self.take_card(card)

    def randomhit(self, dealer):
        hit = randint(0, 1)
        if hit == 1:
            decision = 'H'
        else:
            decision = 'S'
        return decision


    def QLearning_strategy(self, dealer):
        combined = str(self.get_score()) + "_" + str(dealer.get_one_card_score())
        if self.aces >= 1 and len(self.hand) == 2 and self.score > 12:
            if combined in self.QSoftStrategy:
                if self.QSoftStrategy[combined] > 0:
                    decision = 'S'
                elif self.QSoftStrategy[combined] < 0:
                    decision = 'H'
                else:
                    decision = self.randomhit(dealer)
            else:
                decision = self.randomhit(dealer)
        else:
            if combined in self.QStrategy:
                if self.QStrategy[combined] > 0:
                    decision = 'S'
                elif self.QStrategy[combined] < 0:
                    decision = 'H'
                else:
                    decision = self.randomhit(dealer)
            else:
                decision = self.randomhit(dealer)
        return decision


    def updateQStrategy(self, dealer, winner):
        self.hand.pop(-1)
        combined = str(self.get_score()) + "_" + str(dealer.get_one_card_score())
        if self.aces >= 1 and len(self.hand) == 2 and self.score > 12:
            if combined in self.QSoftStrategy:
                self.updateQSoftStrategyDict(combined, winner)
            else:
                self.QSoftStrategy[combined] = 0
                self.updateQSoftStrategyDict(combined, winner)
        else:
            if combined in self.QStrategy:
                self.updateQStrategyDict(combined, winner)
            else:
                self.QStrategy[combined] = 0
                self.updateQStrategyDict(combined, winner)


    def updateQStrategyDict(self, combined, winner):
        if winner == 1:
            self.QStrategy[combined] += 1
        elif winner == 0:
            self.QStrategy[combined] -= 1


    def updateQSoftStrategyDict(self, combined, winner):
        if winner == 1:
            self.QSoftStrategy[combined] += 1
        elif winner == 0:
            self.QSoftStrategy[combined] -= 1


    def update_basicwins(self):
        self.basicwins += 1

    def update_basiclosses(self):
        self.basiclosses += 1

    def update_basicties(self):
        self.basicties += 1
